package presenter;

import awt.Font;
import awt.Color;
import awt.WServer;
import java.lang.String;
import java.lang.Exception;
import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.util.Hashtable;
import java.util.StringTokenizer;
import browser.hotjava;

public class Attr {
   String spec;		// textual representation
   Object value;	// object representation
   String type;		// class or number type
   int id;		// class/type identifier

   public static WServer server = hotjava.server;
   public static Hashtable classDict = new Hashtable();

   public static final int CHAR = 1;
   public static final int BYTE = 2;
   public static final int SHORT = 3;
   public static final int INT = 4;
   public static final int LONG = 5;
   public static final int FLOAT = 6;
   public static final int DOUBLE = 7;

   public static final int CHARACTER = 11;
   public static final int INTEGER = 12;
   public static final int FLOAT_CLASS = 13;
   public static final int DOUBLE_CLASS = 14;

   public static final int COLOR = 21;
   public static final int FONT = 22;

   public static Hashtable typeDict = new Hashtable();

   static {
	typeDict.put("char", new Integer(Attr.CHAR));
	typeDict.put("byte", new Integer(Attr.BYTE));
	typeDict.put("short", new Integer(Attr.SHORT));
	typeDict.put("int", new Integer(Attr.INT));
	typeDict.put("long", new Integer(Attr.LONG));
	typeDict.put("float", new Integer(Attr.FLOAT));
	typeDict.put("double", new Integer(Attr.DOUBLE));
	typeDict.put("Character", new Integer(Attr.CHARACTER));
	typeDict.put("Integer", new Integer(Attr.INTEGER));
	typeDict.put("Float", new Integer(Attr.FLOAT_CLASS));
	typeDict.put("Double", new Integer(Attr.DOUBLE_CLASS));
	typeDict.put("Color", new Integer(Attr.COLOR));
	typeDict.put("Font", new Integer(Attr.FONT));
   }


   public static String getPath() {
	String path = System.getenv("WEBFOILHOME");
	if(path == null) { throw new Exception("undefined WEBFOILHOME"); }
	else { return path + File.separator + "attr"; }
   }

   public static boolean loadFile(String path, AttrDict dict) {
	File file = new File(path);
	if(file.canRead() == false) { return false; }
	DataInputStream data = new DataInputStream(
	new BufferedInputStream(new FileInputStream(path)));
	String line;
	while((line = data.readLine()) != null) {
   	   int c = line.charAt(0);
	   StringTokenizer t;
	   String key;
	   switch(c) {
		case '|': continue;
		case '#':
			t = new StringTokenizer(line.substring(1)," \t");
			key = t.nextToken();
			String value = t.nextToken();
			if(key.equals("include")) {
				Attr.loadFile(Attr.getPath() + value, dict);
			} else 
			if(key.equals("class")) {
				AttrDict ad = (AttrDict)Attr.classDict.get(key);
				if(ad == null) {
					ad = new AttrDict(value);
					Attr.classDict.put(key,ad);
				}
				ad.load();
			}
			break;
		default:
			t = new StringTokenizer(line," \t");
			String type = t.nextToken();
			key = t.nextToken();
			String spec = t.nextToken();
			Attr attr = new Attr(type,spec);
			dict.put(key,attr);
			break;
	   }
	}
	return true;
   }
  
   public Attr(String type, String spec) {
	this.type = type;
	this.spec = spec;
	id = ((Integer)(typeDict.get(type))).intValue();
	switch(id)	{
	case Attr.BYTE:
	case Attr.SHORT:
	case Attr.INT:		value = new Integer(spec); break;
	case Attr.COLOR:	value = ColorAttr.parseSpec(spec); break;
	case Attr.FONT:		value = FontAttr.parseSpec(spec); break;
	}
   }

}
