package presenter;

import java.io.*;
import java.lang.*;
import java.util.*;
import awt.*;

public class AttrDict extends Hashtable {
	String packageName;
	String className;
	String path;

   public static AttrDict init(String key) {
	AttrDict ad = new AttrDict(key);
	Attr.classDict.put(key,ad);
	ad.load();
	return ad;
   }
  
   public int getInt(String key) {
	return getInt(key,0);
   }

   public int getInt(String key, int i) {
	Attr attr = (Attr)get(key);
	if((attr == null)||(attr.id != Attr.INTEGER)) { return i; }
	else { return ((Integer)attr.value).intValue(); }
   }

   public short getShort(String key) {
	return getShort(key,0);
   }

   public short getShort(String key, short i) {
	Attr attr = (Attr)get(key);
	if((attr == null)||(attr.id != Attr.INTEGER)) { return i; }
	else { return (short)(((Integer)attr.value).intValue()); }
   }

   public Font getFont(String key) {
	return getFont(key,FontAttr.defaultValue);
   }

   public Font getFont(String key, Font font) {
	Attr attr = (Attr)get(key);
	if((attr == null) || (attr.id != Attr.FONT))
	{ return font; } else { return (Font)attr.value; }
   }

   public Color getColor(String key) {
	return getColor(key,ColorAttr.defaultValue);
   }

   public Color getColor(String key, Color color) {
	Attr attr = (Attr)get(key);
	if((attr == null) || (attr.id != Attr.COLOR))
	{ return color; } else { return (Color)attr.value; }
   }

   public AttrDict(String key) {
	int i = key.lastIndexOf('.');
	packageName = key.substring(0,i);
	className = key.substring(i+1);
	String sep = File.separator;
	path = Attr.getPath() + sep + "classes" + sep + 
		key.replace('.',sep.charAt(0));
   }

   public boolean load() {
	return Attr.load(path,this);
   }

   public boolean save() {
	try {
	   PrintStream ps = new PrintStream(
	   new BufferedOutputStream(new FileOutputStream(path)));
	   ps.println("|" + new Date());
	   for(Enumeration e = keys(); e.hasMoreElements(); )	{
		String key = (String)(e.nextElement());
		Attr attr = (Attr)get(key);
		ps.println(attr.type + "\t" + key + "\t" + attr.spec);
	   }
	   return true;
	} catch(Exception e) { return false; }
   }

}
