package presenter;

import awt.Color;
import awt.WServer;
import java.lang.String;
import java.lang.Exception;
import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.util.Hashtable;
import java.util.StringTokenizer;
import browser.hotjava;

public class ColorAttr extends Attr {

   public static Hashtable systemDict = new Hashtable();

   static {
	ColorAttr.load("color",systemDict);
   }
  
   public static Color defaultValue = Color.red;

   public static boolean load(String addr, Hashtable dict) {
	try {
	   String path = Attr.getPath() + File.separator + addr;
	   InputStream in = new BufferedInputStream(new FileInputStream(path));
	   DataInputStream data = new DataInputStream(in);
	   String line;
	   while((line = data.readLine()) != null) {
		if(line.startsWith("|")) { continue; }
		StringTokenizer t = new StringTokenizer(line," \t:");
		String key = t.nextToken();
		int r = Integer.parseInt(t.nextToken());
		int g = Integer.parseInt(t.nextToken());
		int b = Integer.parseInt(t.nextToken());
		Color color = new Color(r,b,g);
		dict.put(key, color);
	   }
	   return true;
	} catch(Exception e) { return false; }
   }

   public static Color parseSpec(String spec) {
	Color color;
	int i1 = spec.indexOf(':');
	int i2 = spec.lastIndexOf(':');
	if((i1 < 0)||(i1 == i2)) {
		color = ColorAttr.lookup(spec);
		if(color == null) {
			color = ColorAttr.defaultValue;
		}
		return color;
	}
	int r, g, b;
	r = Integer.parseInt(spec.substring(0,i1));
	g = Integer.parseInt(spec.substring(i1+1,i2));
	b = Integer.parseInt(spec.substring(i2+1));
	color = new Color(r,g,b);
	if(color == null) { color = ColorAttr.defaultValue; }
	return color;
   }


   public static Color lookup(String spec) {
	Color color = (Color)(ColorAttr.systemDict.get(spec));
	return color;
   }

   public ColorAttr(String spec) {
	super("Color", spec);
   }

}
