package presenter;

import awt.Font;
import awt.FontTable;
import awt.WServer;
import java.lang.String;
import java.lang.Exception;
import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.util.Hashtable;
import java.util.StringTokenizer;
import browser.hotjava;

public class FontAttr extends Attr {

   public static Hashtable systemDict = new Hashtable();

   static {
	FontAttr.load("font",systemDict);
   }
   
   public static Font defaultValue;

   public static boolean load(String addr, Hashtable dict) {
	try {
	   String path = Attr.getPath() + File.separator + addr;
	   InputStream in = new BufferedInputStream(new FileInputStream(path));
	   DataInputStream data = new DataInputStream(in);
	   String line;
	   while((line = data.readLine()) != null) {
		if(line.startsWith("|")) { continue; }
		StringTokenizer t = new StringTokenizer(line," \t:");
		String key = t.nextToken();
		String spec = t.nextToken();
		Font font = FontAttr.parseSpec(spec);
		dict.put(key,font);
	   }
	   return true;
	} catch(Exception e) { return false; }
   }

   public static Font parseSpec(String spec) {
	Font font;
	int i1 = spec.indexOf(':');
	int i2 = spec.lastIndexOf(':');
	if((i1 < 0)||(i1 == i2)) {
		font = FontAttr.lookup(spec);
		if(font == null)	{
			font = FontAttr.defaultValue;
		}
		return font;
	}
	String type = spec.substring(0,i1);
	String style = spec.substring(i1+1,i2);
	int size = Integer.parseInt(spec.substring(i2+1));
	int id = 0, i = 0, cnt = style.length(), c;
	while(cnt-- > 0) {
   	   switch(c = style.charAt(i++))	{
		case 'p': id &= ~(Font.BOLD | Font.ITALIC); break;
		case 'b': id |= Font.BOLD; break;
		case 'i': id |= Font.ITALIC; break;
		case 'u': id |= Font.UNDERLINE; break;
		}
	}
	font = hotjava.server.fonts.getFont(type,id,size);
	if(font == null) { font = FontAttr.defaultValue; }
	return font;
   }

   public static Font lookup(String spec) {
	Font font = (Font)(FontAttr.systemDict.get(spec));
	return font;
   }


   public FontAttr(String spec) {
	super("Font",spec);
   }

}
