package presenter;

import awt.*;
import java.util.*;
import browser.WRWindow;
import browser.WRFormatter;
import browser.Document;
import presenter.MenuBarManager;
import presenter.MenuGroup;

public class FontMenuGroup extends MenuGroup	{

   static String fontTypeList[] = 	{
		"Helvetica",	"TimesRoman",	"ZapfDingbats",
		"Dialog",	"DialogInput",	"Courier"
					};
   static String fontStyleList[] =	{
		"PLAIN",	"BOLD",		"ITALIC",
		"UNDERLINE"
					};
   static int fontStyleVec[] =		{
		Font.PLAIN,	Font.BOLD,	Font.ITALIC,
		Font.UNDERLINE
					};
   static String fontColorList[] =	{
		"black",	"blue",		"cyan",		"darkGray",
		"gray",		"green",	"magenta",	"menuBack",
		"menuBright",	"menuDim",	"menuFore",
		"menuHighlight",		"orange",	"pink",
		"red",		"white",	"yellow"
					};
   static Color fontColorVec[] =		{
		Color.black,	Color.blue,	Color.cyan,	Color.darkGray,
		Color.gray,	Color.green,	Color.magenta,	Color.menuBack,
		Color.menuBright,		Color.menuDim,
		Color.menuFore,	Color.menuHighlight,		Color.orange,
		Color.pink,	Color.red,	Color.white,	Color.yellow
					};
   static String fontSizeList[] =		{
		"8",	"10",	"12",	"14",	"24",	"36"
					};
   static int fontSizeVec[] =		{
		8,	10,	12,	14,	24,	36
					};
   MenuBarManager mbm;
   MenuBar mb;
   String fontType = "Helvetica";
   String fontStyle = "BOLD";
   int fontStyleValue = Font.BOLD;
   String fontSize = "14";
   int fontSizeValue = 14;
   int fontSizeIndex = 3;
   String fontColor = "white";
   Color fontColorValue = Color.white;
   String winColor = "blue";
   Color winColorValue = Color.blue;
   MenuItem tpmit, stmit, clmit, szmit, wclmit;

   public FontMenuGroup(MenuBarManager mbm)	{
	super("Fonts",mbm);
	this.mbm = mbm;
	mb = mbm.mb;
	addElement(new FontTypeMenu("FontType",mb,false,this));
	addElement(new FontStyleMenu("FontStyle",mb,false,this));
	addElement(new FontSizeMenu("FontSize",mb,false,this));
	addElement(new FontColorMenu("FgColor",mb,false,this));
	addElement(new WinColorMenu("BgColor",mb,false,this));

   }
   public void setBackground()	{
	WRWindow wrw = mbm.wrw;
	wrw.unMap();
	wrw.setBackground(winColorValue);
	wrw.update();
	wrw.map();
	}
   public void repaint() {
	FormattingParameters fp = new FormattingParameters(null);
	fp.fontAttr = (byte)fontStyleValue;
	fp.fontSize = (byte)fontSizeValue;
	fp.fontName = fontType;
	fp.r = (short)fontColorValue.r;
	fp.g = (short)fontColorValue.g;
	fp.b = (short)fontColorValue.b;
	WRWindow wrw = mbm.wrw;
	WRFormatter wrf = wrw.getFormatter();
	Document doc = wrf.getDocument();
	wrf = new WRFormatter(wrw,doc);
	wrf.setParameters(fp);
	wrw.setFormatter(wrf);
	int titleSizeValue = 36;
	if(fontSizeIndex < 5) { titleSizeValue = fontSizeVec[fontSizeIndex+1]; }
	Document.setStyleAttributes(fontSizeValue, titleSizeValue);
	wrw.layoutDocument();
	wrw.status("Font reset completed");
   }

}
  
class FontTypeMenu extends Menu			{
	
	Vector mitv;
	FontMenuGroup fmg;

public FontTypeMenu(String key, MenuBar mb, boolean b, FontMenuGroup fmg) 
								{
		super(key,mb,b);
		MenuItem mit;
		this.fmg = fmg;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<fmg.fontTypeList.length; i++)	{
			mark =
			(fmg.fontType.compareTo(fmg.fontTypeList[i]) == 0) ?
			true : false;
			mit = new MenuItem(fmg.fontTypeList[i],this,false);
			if(mark) {  fmg.tpmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index)	{
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		fmg.tpmit = mit;
		fmg.fontType = mit.label;
		fmg.repaint();
					}
						}


class FontStyleMenu extends Menu		{
	Vector mitv;
	FontMenuGroup fmg;

public FontStyleMenu(String key, MenuBar mb, boolean b, FontMenuGroup fmg) 
								{
		super(key,mb,b);
		MenuItem mit;
		this.fmg = fmg;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<fmg.fontStyleList.length; i++)        {
			mark =
			(fmg.fontStyle.compareTo(fmg.fontStyleList[i]) == 0) ?
			true : false;
			mit = new MenuItem(fmg.fontStyleList[i],this,true);
			if(mark) { fmg.stmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index) {
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		fmg.stmit = mit;
		fmg.fontStyle = mit.label;
		fmg.fontStyleValue = fmg.fontStyleVec[index];
		fmg.repaint();
					}

						}

class FontColorMenu extends Menu		{
	Vector mitv;
	FontMenuGroup fmg;

public FontColorMenu(String key, MenuBar mb, boolean b, FontMenuGroup fmg)
								{
		super(key,mb,b);
		MenuItem mit;
		this.fmg = fmg;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<fmg.fontColorList.length; i++)        {
			mark =
			(fmg.fontColor.compareTo(fmg.fontColorList[i]) == 0) ?
			true : false;
			mit = new MenuItem(fmg.fontColorList[i],this,true);
			if(mark) { fmg.clmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index)	{
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		fmg.clmit = mit;
		fmg.fontColor = mit.label;
		fmg.fontColorValue = fmg.fontColorVec[index];
		fmg.repaint();
					}
						}

class FontSizeMenu extends Menu			{
	Vector mitv;
	FontMenuGroup fmg;

public FontSizeMenu(String key, MenuBar mb, boolean b, FontMenuGroup fmg)
								{
		super(key,mb,b);
		MenuItem mit;
		this.fmg = fmg;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<fmg.fontSizeList.length; i++)        {
			mark =
			(fmg.fontSize.compareTo(fmg.fontSizeList[i]) == 0) ?
			true : false;
			mit = new MenuItem(fmg.fontSizeList[i],this,true);
			if(mark) { fmg.szmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index) {
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		fmg.szmit = mit;
		fmg.fontSize = mit.label;
		fmg.fontSizeValue = fmg.fontSizeVec[index];
		fmg.fontSizeIndex = index;
		fmg.repaint();
					}
						}

class WinColorMenu extends Menu                {
        Vector mitv;
        FontMenuGroup fmg;

public WinColorMenu(String key, MenuBar mb, boolean b, FontMenuGroup fmg)
                                                                {
                super(key,mb,b);
                MenuItem mit;
                this.fmg = fmg;
                mitv = new Vector();
                int i; boolean mark;
                for(i=0; i<fmg.fontColorList.length; i++)        {
                        mark =
                        (fmg.winColor.compareTo(fmg.fontColorList[i]) == 0) ?
                        true : false;
                        mit = new MenuItem(fmg.fontColorList[i],this,true);
                        if(mark) { fmg.wclmit = mit; }
                        mitv.addElement(mit);
                                                                }
                                                                }
        public void selected(int index) {
                MenuItem mit = (MenuItem)mitv.elementAt(index);
                fmg.wclmit = mit;
                fmg.winColor = mit.label;
                fmg.winColorValue = fmg.fontColorVec[index];
                fmg.setBackground();
                                        }
                                                }
      
