package presenter;

import java.io.*;
import java.lang.*;
import java.util.*;
import awt.*;
import browser.*;
import net.www.html.URL;

public class SourceEditor extends Frame {
    URL url;
    String urlString;
    TextArea ta;
    Label	status;
    hotjava hj;
    Document doc;
    Document currDoc;
    WRWindow wrw;
    WRFormatter wrf;
    public WRFormatter currWrf;
    Stack versionStack;
    MenuBar mbar;
    Menu fileMenu; 
    Menu optMenu;
    Menu helpMenu;
    FileDialog fdialog;
    int versionCount;
    EditVersion ev;
    Hashtable DocRootDict;
    int fontSize;
    
    public SourceEditor(hotjava hj, URL url) {
	super(hotjava.server, true, hj, 820, 750, Color.pink);

	this.url = url;
	urlString = url.toExternalForm();
	wrw = hj.getWindow();
	wrf = wrw.getFormatter();
	doc = wrf.getDocument();
	if(hj.windoze) { fontSize = 14; } else { fontSize = 24; }
	Font defaultFont = wServer.fonts.getFont("Courier", Font.PLAIN, 14);
	Font dialogFont = wServer.fonts.getFont("Dialog",Font.BOLD,fontSize);
	setDefaultFont(dialogFont);
	setTitle("Source Editor " + url.toExternalForm());
	Window w = new Window(this, "Center", background, 768, 512);
	mbar = new MenuBar(this);
	fileMenu = new EditorFileMenu(mbar,this);
//	optMenu = new EditoOptionsMenu(mbar,this);
//	helpMenu = new HelpMenu(mbar,this);
	w.setLayout(new ColumnLayout(true));
	ta = new TextArea(w, "Center", defaultFont, 80, 25);
	ta.setHFill(true);
	ta.setVFill(true);
	ta.setEditable(true);
	w = new Window(this,"North",background,768,200);
	w.setLayout(new ColumnLayout(true));
	
	status = new Label("",null, w, defaultFont);
	status.setHFill(true);
	map();
	resize();
	versionStack = new Stack();
	initText();
	DocRootDict = new Hashtable();
	DocRootDict.put(
		"http://naos.npac.syr.edu:2009", 
		"/hpdc4/furm/web/world/webfoil"
	);
	DocRootDict.put(
		"http://king.syr.edu:2006",
		"/home/B4D/MOVIE/users/furm/Web/World"
	);
	DocRootDict.put(
		"http://kayak.npac.syr.edu:2005",
		"/net/kayak/export/project/kyk01/cps600/web/world"
	);
	DocRootDict.put(
		"http://kayak.npac.syr.edu:2007",
		"/net/kayak/export/project/kyk01/furma/Web/Server/wt"
	);
	DocRootDict.put(
		"http://www.npac.syr.edu",
		"/home/R8E/gcf/foils"
	);
    }

    public void print(String s) { System.out.println(s); }

    public void initText() {
        InputStream in = null;
        try {
            in = url.openStream();
        } catch (FileNotFoundException e) {
            ta.setText("");      // can you say HACK?
            return;
        }
        OutputStreamBuffer out = new OutputStreamBuffer();
        byte buffer[] = new byte[1024];
        while (true) {
            int n = in.read(buffer, 0, buffer.length);
            if (n < 0) {
                break;
            }
            out.write(buffer, 0, n);
        }
        in.close();
        ta.setText(out.toString());
	this.status.setText("Original of " + urlString);
    }

   public void view()	{
	ev = new EditVersion(this);
	versionStack.push(ev);
	versionCount++;
	ev.show();
   }

   public void undo()	{
	if(versionCount == 0) return;
	versionStack.pop(); 
	versionCount--;
	if(versionCount == 0)	{
		initText();
		wrw.pushURL(url);
		return;
	}
	ev = (EditVersion)versionStack.peek();
	ev.show();
   }
  
   public void save()	{
	if(url.protocol.equals("doc")) { save_nt(); return; }
	String path;
	String server = url.protocol + "://" + url.host;
	if(url.port != -1) { server = server + ":" + url.port; }
	String docroot = (String)DocRootDict.get(server);
	if(server.equals("http://kayak.npac.syr.edu:2007") &&
	(url.file).startsWith("/users")) 	{
		path = "/net/kayak/export/project/kyk01/furma" + url.file;
					}
	else				{
		path = docroot + url.file;
					}
	if(path.endsWith("/")) { path = path + "index.html"; }
print("server = " + server);
print("docroot = " + docroot);
print("path = " + path);
	try {
		File f = new File(path);
		PrintStream ps = new PrintStream(new FileOutputStream(f));
		ps.print(ta.getText());
		ps.close();
	} catch(Exception e) { 
		this.status.setText("Save error: " + path);
		return;
	}
	this.status.setText("Saved " + path);
   }

   public void save_nt()	{
	String path;
	String s = url.file.substring(1);
	StringTokenizer t = new StringTokenizer(s,"\\/");
	path = "d:\\temp\\hotjava";
	while(t.hasMoreElements())	{
		s = t.nextToken();
		path = path + "\\" + s;
	}
        try {
                File f = new File(path);
                PrintStream ps = new PrintStream(new FileOutputStream(f));
                ps.print(ta.getText());
                ps.close();
        } catch(Exception e) {
                this.status.setText("Save error: " + path);
                return;
        }
        this.status.setText("Saved " + path);
   }

   public void saveAs()	{
	if(url.protocol.equals("doc")) { saveAs_nt(); return; }
        if (fdialog == null) {
            fdialog = new FileDialog("Save HTML Source...", this);
        }
	String path = fdialog.chooseFile("/home/B8F/furm");

        if (path != null) {
            try {
                File fpath = new File(path);
                PrintStream pStr = new PrintStream(new FileOutputStream(fpath));
                pStr.print(this.ta.getText());
                pStr.close();
            } catch (Exception e) {
                this.status.setText("Error writing to " + path);
                return;
            }
            this.status.setText("Wrote " + path);
        }
    }

   public void saveAs_nt() {
	if (fdialog == null) {
            fdialog = new FileDialog("Save HTML Source...", this);
        }
	String path = fdialog.chooseFile("d:\\temp\\hotjava");
	if (path != null) {
            try {
                File fpath = new File(path);
                PrintStream pStr = new PrintStream(new FileOutputStream(fpath));
                pStr.print(this.ta.getText());
                pStr.close();
            } catch (Exception e) {
                this.status.setText("Error writing to " + path);
                return;
            }
            this.status.setText("Wrote " + path);
        }
    }

   public void reset()	{
	while(versionCount-- > 0) { versionStack.pop(); }
	initText();
	wrw.pushURL(url);
   }

   public void quit()	{
	unMap();
   }

}
  
class EditorFileMenu extends Menu	{
	SourceEditor se;

    public EditorFileMenu(MenuBar mb, SourceEditor se)	{
	super("File",mb);
	this.se = se;

	new MenuItem("View",this);
	new MenuItem("Save",this);
	new MenuItem("Save As...",this);
	new MenuItem("Undo",this);
	new MenuItem("Reset",this);
	new MenuItem("Quit",this);

   }
 
   public void selected(int index)	{
	switch(index)	{
		case 0:	// View
			se.view();
			break;

		case 1: //Save
			se.save();
			break;

		case 2: //SaveAs
			se.saveAs();
			break;

		case 3: //Undo
			se.undo();
			break;

		case 4: //Reset
			se.reset();
			break;

		case 5: //Quit
			se.quit();
			break;

	}
   }
}

class EditVersion	{
	hotjava hj;
	WRWindow wrw;
	URL url;
	TextArea ta;
	SourceEditor se;
	Document doc;
	WRFormatter wrf;
	FormattingParameters fp;
	String script;
	int versionIndex;

   public EditVersion(SourceEditor se)	{
	this.se = se;
	hj = se.hj; 
	ta = se.ta;
	wrw = se.wrw;
	url = se.url;
	String s  = ta.getText();
	if(!s.startsWith("<html>")) {
		script = "<html>\n" + s + "\n</html>\n";
	} else { script = s; }
	doc = new browser.Document(se.url,script);
	versionIndex = se.versionCount + 1;
   }

   public void show()	{
	wrf = new WRFormatter(wrw,doc);
	fp = makeParameters();
	wrf.setParameters(fp);
	wrw.setFormatter(wrf);
	wrw.layoutDocument();
	se.status.setText("Edit " + versionIndex + " of " + se.urlString);
   }

   public FormattingParameters makeParameters()	{
	FormattingParameters fp = new FormattingParameters(null);
	fp.fontName = "Helvetica";
	fp.fontAttr = FormattingParameters.BOLD;
	int fs;
	if(hj.windoze) { fs = 14; } else { fs = 24; }
	fp.fontSize = (byte)fs;
	fp.r = 255; fp.g = 255; fp.b = 255;
	return fp;
   }
}
